package io.fabric8.kubernetes.api.model.apiextensions.v1;

import io.fabric8.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;
public class ConversionRequestBuilder extends io.fabric8.kubernetes.api.model.apiextensions.v1.ConversionRequestFluentImpl<io.fabric8.kubernetes.api.model.apiextensions.v1.ConversionRequestBuilder> implements io.fabric8.kubernetes.api.builder.VisitableBuilder<io.fabric8.kubernetes.api.model.apiextensions.v1.ConversionRequest,io.fabric8.kubernetes.api.model.apiextensions.v1.ConversionRequestBuilder>{
  public ConversionRequestBuilder() {
    this(false);
  }
  public ConversionRequestBuilder(java.lang.Boolean validationEnabled) {
    this(new ConversionRequest(), validationEnabled);
  }
  public ConversionRequestBuilder(io.fabric8.kubernetes.api.model.apiextensions.v1.ConversionRequestFluent<?> fluent) {
    this(fluent, false);
  }
  public ConversionRequestBuilder(io.fabric8.kubernetes.api.model.apiextensions.v1.ConversionRequestFluent<?> fluent,java.lang.Boolean validationEnabled) {
    this(fluent, new ConversionRequest(), validationEnabled);
  }
  public ConversionRequestBuilder(io.fabric8.kubernetes.api.model.apiextensions.v1.ConversionRequestFluent<?> fluent,io.fabric8.kubernetes.api.model.apiextensions.v1.ConversionRequest instance) {
    this(fluent, instance, false);
  }
  public ConversionRequestBuilder(io.fabric8.kubernetes.api.model.apiextensions.v1.ConversionRequestFluent<?> fluent,io.fabric8.kubernetes.api.model.apiextensions.v1.ConversionRequest instance,java.lang.Boolean validationEnabled) {
    this.fluent = fluent; 
    fluent.withDesiredAPIVersion(instance.getDesiredAPIVersion()); 
    fluent.withObjects(instance.getObjects()); 
    fluent.withUid(instance.getUid()); 
    this.validationEnabled = validationEnabled; 
  }
  public ConversionRequestBuilder(io.fabric8.kubernetes.api.model.apiextensions.v1.ConversionRequest instance) {
    this(instance,false);
  }
  public ConversionRequestBuilder(io.fabric8.kubernetes.api.model.apiextensions.v1.ConversionRequest instance,java.lang.Boolean validationEnabled) {
    this.fluent = this; 
    this.withDesiredAPIVersion(instance.getDesiredAPIVersion()); 
    this.withObjects(instance.getObjects()); 
    this.withUid(instance.getUid()); 
    this.validationEnabled = validationEnabled; 
  }
  io.fabric8.kubernetes.api.model.apiextensions.v1.ConversionRequestFluent<?> fluent;
  java.lang.Boolean validationEnabled;
  public io.fabric8.kubernetes.api.model.apiextensions.v1.ConversionRequest build() {
    ConversionRequest buildable = new ConversionRequest(fluent.getDesiredAPIVersion(),fluent.getObjects(),fluent.getUid());
    return buildable;
  }
  public boolean equals(java.lang.Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    if (!super.equals(o)) return false;
    ConversionRequestBuilder that = (ConversionRequestBuilder) o;
    if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

    if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
    return true;
  }
  public int hashCode() {
    return java.util.Objects.hash(fluent,  validationEnabled,  super.hashCode());
  }
  
}