package io.fabric8.kubernetes.api.model.apiextensions.v1beta1;

import io.fabric8.kubernetes.api.builder.Nested;
import java.util.ArrayList;
import java.lang.String;
import java.util.function.Predicate;
import java.lang.Integer;
import java.lang.Deprecated;
import io.fabric8.kubernetes.api.builder.BaseFluent;
import java.util.Collection;
import java.lang.Object;
import java.util.List;
import java.lang.Boolean;

 /**
  * Generated
  */
public class CustomResourceConversionFluentImpl<A extends io.fabric8.kubernetes.api.model.apiextensions.v1beta1.CustomResourceConversionFluent<A>> extends io.fabric8.kubernetes.api.builder.BaseFluent<A> implements io.fabric8.kubernetes.api.model.apiextensions.v1beta1.CustomResourceConversionFluent<A>{
  public CustomResourceConversionFluentImpl() {
  }
  public CustomResourceConversionFluentImpl(io.fabric8.kubernetes.api.model.apiextensions.v1beta1.CustomResourceConversion instance) {
    this.withConversionReviewVersions(instance.getConversionReviewVersions()); 
    this.withStrategy(instance.getStrategy()); 
    this.withWebhookClientConfig(instance.getWebhookClientConfig()); 
  }
  private java.util.List<java.lang.String> conversionReviewVersions = new java.util.ArrayList<java.lang.String>();
  private java.lang.String strategy;
  private io.fabric8.kubernetes.api.model.apiextensions.v1beta1.WebhookClientConfigBuilder webhookClientConfig;
  public A addToConversionReviewVersions(java.lang.Integer index,java.lang.String item) {
    if (this.conversionReviewVersions == null) {this.conversionReviewVersions = new java.util.ArrayList<java.lang.String>();}
    this.conversionReviewVersions.add(index, item);
    return (A)this;
  }
  public A setToConversionReviewVersions(java.lang.Integer index,java.lang.String item) {
    if (this.conversionReviewVersions == null) {this.conversionReviewVersions = new java.util.ArrayList<java.lang.String>();}
    this.conversionReviewVersions.set(index, item); return (A)this;
  }
  public A addToConversionReviewVersions(java.lang.String... items) {
    if (this.conversionReviewVersions == null) {this.conversionReviewVersions = new java.util.ArrayList<java.lang.String>();}
    for (java.lang.String item : items) {this.conversionReviewVersions.add(item);} return (A)this;
  }
  public A addAllToConversionReviewVersions(java.util.Collection<java.lang.String> items) {
    if (this.conversionReviewVersions == null) {this.conversionReviewVersions = new java.util.ArrayList<java.lang.String>();}
    for (java.lang.String item : items) {this.conversionReviewVersions.add(item);} return (A)this;
  }
  public A removeFromConversionReviewVersions(java.lang.String... items) {
    for (java.lang.String item : items) {if (this.conversionReviewVersions!= null){ this.conversionReviewVersions.remove(item);}} return (A)this;
  }
  public A removeAllFromConversionReviewVersions(java.util.Collection<java.lang.String> items) {
    for (java.lang.String item : items) {if (this.conversionReviewVersions!= null){ this.conversionReviewVersions.remove(item);}} return (A)this;
  }
  public java.util.List<java.lang.String> getConversionReviewVersions() {
    return this.conversionReviewVersions;
  }
  public java.lang.String getConversionReviewVersion(java.lang.Integer index) {
    return this.conversionReviewVersions.get(index);
  }
  public java.lang.String getFirstConversionReviewVersion() {
    return this.conversionReviewVersions.get(0);
  }
  public java.lang.String getLastConversionReviewVersion() {
    return this.conversionReviewVersions.get(conversionReviewVersions.size() - 1);
  }
  public java.lang.String getMatchingConversionReviewVersion(java.util.function.Predicate<java.lang.String> predicate) {
    for (java.lang.String item: conversionReviewVersions) { if(predicate.test(item)){ return item;} } return null;
  }
  public java.lang.Boolean hasMatchingConversionReviewVersion(java.util.function.Predicate<java.lang.String> predicate) {
    for (java.lang.String item: conversionReviewVersions) { if(predicate.test(item)){ return true;} } return false;
  }
  public A withConversionReviewVersions(java.util.List<java.lang.String> conversionReviewVersions) {
    if (conversionReviewVersions != null) {this.conversionReviewVersions = new java.util.ArrayList<java.lang.String>(); for (java.lang.String item : conversionReviewVersions){this.addToConversionReviewVersions(item);}} else { this.conversionReviewVersions = null;} return (A) this;
  }
  public A withConversionReviewVersions(java.lang.String... conversionReviewVersions) {
    if (this.conversionReviewVersions != null) {this.conversionReviewVersions.clear();}
    if (conversionReviewVersions != null) {for (java.lang.String item :conversionReviewVersions){ this.addToConversionReviewVersions(item);}} return (A) this;
  }
  public java.lang.Boolean hasConversionReviewVersions() {
    return conversionReviewVersions != null && !conversionReviewVersions.isEmpty();
  }
  public A addNewConversionReviewVersion(java.lang.String arg0) {
    return (A)addToConversionReviewVersions(new String(arg0));
  }
  public java.lang.String getStrategy() {
    return this.strategy;
  }
  public A withStrategy(java.lang.String strategy) {
    this.strategy=strategy; return (A) this;
  }
  public java.lang.Boolean hasStrategy() {
    return this.strategy != null;
  }
  
  /**
   * Method is deprecated. use withStrategy instead.
   */
  @java.lang.Deprecated
  public A withNewStrategy(java.lang.String arg0) {
    return (A)withStrategy(new String(arg0));
  }
  
  /**
   * This method has been deprecated, please use method buildWebhookClientConfig instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public io.fabric8.kubernetes.api.model.apiextensions.v1beta1.WebhookClientConfig getWebhookClientConfig() {
    return this.webhookClientConfig!=null?this.webhookClientConfig.build():null;
  }
  public io.fabric8.kubernetes.api.model.apiextensions.v1beta1.WebhookClientConfig buildWebhookClientConfig() {
    return this.webhookClientConfig!=null?this.webhookClientConfig.build():null;
  }
  public A withWebhookClientConfig(io.fabric8.kubernetes.api.model.apiextensions.v1beta1.WebhookClientConfig webhookClientConfig) {
    _visitables.get("webhookClientConfig").remove(this.webhookClientConfig);
    if (webhookClientConfig!=null){ this.webhookClientConfig= new io.fabric8.kubernetes.api.model.apiextensions.v1beta1.WebhookClientConfigBuilder(webhookClientConfig); _visitables.get("webhookClientConfig").add(this.webhookClientConfig);} return (A) this;
  }
  public java.lang.Boolean hasWebhookClientConfig() {
    return this.webhookClientConfig != null;
  }
  public io.fabric8.kubernetes.api.model.apiextensions.v1beta1.CustomResourceConversionFluent.WebhookClientConfigNested<A> withNewWebhookClientConfig() {
    return new io.fabric8.kubernetes.api.model.apiextensions.v1beta1.CustomResourceConversionFluentImpl.WebhookClientConfigNestedImpl();
  }
  public io.fabric8.kubernetes.api.model.apiextensions.v1beta1.CustomResourceConversionFluent.WebhookClientConfigNested<A> withNewWebhookClientConfigLike(io.fabric8.kubernetes.api.model.apiextensions.v1beta1.WebhookClientConfig item) {
    return new io.fabric8.kubernetes.api.model.apiextensions.v1beta1.CustomResourceConversionFluentImpl.WebhookClientConfigNestedImpl(item);
  }
  public io.fabric8.kubernetes.api.model.apiextensions.v1beta1.CustomResourceConversionFluent.WebhookClientConfigNested<A> editWebhookClientConfig() {
    return withNewWebhookClientConfigLike(getWebhookClientConfig());
  }
  public io.fabric8.kubernetes.api.model.apiextensions.v1beta1.CustomResourceConversionFluent.WebhookClientConfigNested<A> editOrNewWebhookClientConfig() {
    return withNewWebhookClientConfigLike(getWebhookClientConfig() != null ? getWebhookClientConfig(): new io.fabric8.kubernetes.api.model.apiextensions.v1beta1.WebhookClientConfigBuilder().build());
  }
  public io.fabric8.kubernetes.api.model.apiextensions.v1beta1.CustomResourceConversionFluent.WebhookClientConfigNested<A> editOrNewWebhookClientConfigLike(io.fabric8.kubernetes.api.model.apiextensions.v1beta1.WebhookClientConfig item) {
    return withNewWebhookClientConfigLike(getWebhookClientConfig() != null ? getWebhookClientConfig(): item);
  }
  public boolean equals(java.lang.Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    CustomResourceConversionFluentImpl that = (CustomResourceConversionFluentImpl) o;
    if (conversionReviewVersions != null ? !conversionReviewVersions.equals(that.conversionReviewVersions) :that.conversionReviewVersions != null) return false;
    if (strategy != null ? !strategy.equals(that.strategy) :that.strategy != null) return false;
    if (webhookClientConfig != null ? !webhookClientConfig.equals(that.webhookClientConfig) :that.webhookClientConfig != null) return false;
    return true;
  }
  public int hashCode() {
    return java.util.Objects.hash(conversionReviewVersions,  strategy,  webhookClientConfig,  super.hashCode());
  }
  public class WebhookClientConfigNestedImpl<N> extends io.fabric8.kubernetes.api.model.apiextensions.v1beta1.WebhookClientConfigFluentImpl<io.fabric8.kubernetes.api.model.apiextensions.v1beta1.CustomResourceConversionFluent.WebhookClientConfigNested<N>> implements io.fabric8.kubernetes.api.model.apiextensions.v1beta1.CustomResourceConversionFluent.WebhookClientConfigNested<N>,io.fabric8.kubernetes.api.builder.Nested<N>{
    WebhookClientConfigNestedImpl(io.fabric8.kubernetes.api.model.apiextensions.v1beta1.WebhookClientConfig item) {
      this.builder = new io.fabric8.kubernetes.api.model.apiextensions.v1beta1.WebhookClientConfigBuilder(this, item);
    }
    WebhookClientConfigNestedImpl() {
      this.builder = new io.fabric8.kubernetes.api.model.apiextensions.v1beta1.WebhookClientConfigBuilder(this);
    }
    io.fabric8.kubernetes.api.model.apiextensions.v1beta1.WebhookClientConfigBuilder builder;
    public N and() {
      return (N) CustomResourceConversionFluentImpl.this.withWebhookClientConfig(builder.build());
    }
    public N endWebhookClientConfig() {
      return and();
    }
    
  }
  
}